diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index e770ea6eb8..3c4778a5d4 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -1664,7 +1664,7 @@ RemoveAttributeById(Oid relid, AttrNumber attnum)
 	if (!HeapTupleIsValid(tuple))	/* shouldn't happen */
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 attnum, relid);
-	attStruct = (Form_pg_attribute) GETSTRUCT(tuple);
+	attStruct = GETSTRUCT(pg_attribute, tuple);
 
 	if (attnum < 0)
 	{
@@ -1776,7 +1776,7 @@ heap_drop_with_catalog(Oid relid)
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	if (((Form_pg_class) GETSTRUCT(tuple))->relispartition)
+	if ((GETSTRUCT(pg_class, tuple))->relispartition)
 	{
 		/*
 		 * We have to lock the parent if the partition is being detached,
@@ -1973,7 +1973,7 @@ RelationClearMissing(Relation rel)
 			elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 				 attnum, relid);
 
-		attrtuple = (Form_pg_attribute) GETSTRUCT(tuple);
+		attrtuple = GETSTRUCT(pg_attribute, tuple);
 
 		/* ignore any where atthasmissing is not true */
 		if (attrtuple->atthasmissing)
@@ -2032,7 +2032,7 @@ SetAttrMissing(Oid relid, char *attname, char *value)
 	if (!HeapTupleIsValid(atttup))
 		elog(ERROR, "cache lookup failed for attribute %s of relation %u",
 			 attname, relid);
-	attStruct = (Form_pg_attribute) GETSTRUCT(atttup);
+	attStruct = GETSTRUCT(pg_attribute, atttup);
 
 	/* get an array value from the value string */
 	missingval = OidFunctionCall3(F_ARRAY_IN,
@@ -2536,7 +2536,7 @@ MergeWithExistingConstraint(Relation rel, const char *ccname, Node *expr,
 	/* There can be at most one matching row */
 	if (HeapTupleIsValid(tup = systable_getnext(conscan)))
 	{
-		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(tup);
+		Form_pg_constraint con = GETSTRUCT(pg_constraint, tup);
 
 		/* Found it.  Conflicts if not identical check constraint */
 		if (con->contype == CONSTRAINT_CHECK)
@@ -2605,7 +2605,7 @@ MergeWithExistingConstraint(Relation rel, const char *ccname, Node *expr,
 						ccname)));
 
 		tup = heap_copytuple(tup);
-		con = (Form_pg_constraint) GETSTRUCT(tup);
+		con = GETSTRUCT(pg_constraint, tup);
 
 		/*
 		 * In case of partitions, an inherited constraint must be inherited
@@ -2663,7 +2663,7 @@ SetRelationNumChecks(Relation rel, int numchecks)
 	if (!HeapTupleIsValid(reltup))
 		elog(ERROR, "cache lookup failed for relation %u",
 			 RelationGetRelid(rel));
-	relStruct = (Form_pg_class) GETSTRUCT(reltup);
+	relStruct = GETSTRUCT(pg_class, reltup);
 
 	if (relStruct->relchecks != numchecks)
 	{
@@ -2882,7 +2882,7 @@ CopyStatistics(Oid fromrelid, Oid torelid)
 
 		/* make a modifiable copy */
 		tup = heap_copytuple(tup);
-		statform = (Form_pg_statistic) GETSTRUCT(tup);
+		statform = GETSTRUCT(pg_statistic, tup);
 
 		/* update the copy of the tuple and insert it */
 		statform->starelid = torelid;
@@ -3207,7 +3207,7 @@ restart:
 
 	while (HeapTupleIsValid(tuple = systable_getnext(fkeyScan)))
 	{
-		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(tuple);
+		Form_pg_constraint con = GETSTRUCT(pg_constraint, tuple);
 
 		/* Not a foreign key */
 		if (con->contype != CONSTRAINT_FOREIGN)
@@ -3259,7 +3259,7 @@ restart:
 		tuple = systable_getnext(fkeyScan);
 		if (HeapTupleIsValid(tuple))
 		{
-			Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(tuple);
+			Form_pg_constraint con = GETSTRUCT(pg_constraint, tuple);
 
 			/*
 			 * pg_constraint rows always appear for partitioned hierarchies
@@ -3486,7 +3486,7 @@ StorePartitionBound(Relation rel, Relation parent, PartitionBoundSpec *bound)
 		Form_pg_class classForm;
 		bool		isnull;
 
-		classForm = (Form_pg_class) GETSTRUCT(tuple);
+		classForm = GETSTRUCT(pg_class, tuple);
 		Assert(!classForm->relispartition);
 		(void) SysCacheGetAttr(RELOID, tuple, Anum_pg_class_relpartbound,
 							   &isnull);
@@ -3504,7 +3504,7 @@ StorePartitionBound(Relation rel, Relation parent, PartitionBoundSpec *bound)
 	newtuple = heap_modify_tuple(tuple, RelationGetDescr(classRel),
 								 new_val, new_null, new_repl);
 	/* Also set the flag */
-	((Form_pg_class) GETSTRUCT(newtuple))->relispartition = true;
+	(GETSTRUCT(pg_class, newtuple))->relispartition = true;
 	CatalogTupleUpdate(classRel, &newtuple->t_self, newtuple);
 	heap_freetuple(newtuple);
 	table_close(classRel, RowExclusiveLock);
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index c5d463ac55..bd909be6d1 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -170,7 +170,7 @@ relationHasPrimaryKey(Relation rel)
 		indexTuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexoid));
 		if (!HeapTupleIsValid(indexTuple))	/* should not happen */
 			elog(ERROR, "cache lookup failed for index %u", indexoid);
-		result = ((Form_pg_index) GETSTRUCT(indexTuple))->indisprimary;
+		result = (GETSTRUCT(pg_index, indexTuple))->indisprimary;
 		ReleaseSysCache(indexTuple);
 		if (result)
 			break;
@@ -251,7 +251,7 @@ index_check_primary_key(Relation heapRel,
 		if (!HeapTupleIsValid(atttuple))
 			elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 				 attnum, RelationGetRelid(heapRel));
-		attform = (Form_pg_attribute) GETSTRUCT(atttuple);
+		attform = GETSTRUCT(pg_attribute, atttuple);
 
 		if (!attform->attnotnull)
 			ereport(ERROR,
@@ -369,7 +369,7 @@ ConstructTupleDescriptor(Relation heapRelation,
 			tuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(keyType));
 			if (!HeapTupleIsValid(tuple))
 				elog(ERROR, "cache lookup failed for type %u", keyType);
-			typeTup = (Form_pg_type) GETSTRUCT(tuple);
+			typeTup = GETSTRUCT(pg_type, tuple);
 
 			/*
 			 * Assign some of the attributes values. Leave the rest.
@@ -426,7 +426,7 @@ ConstructTupleDescriptor(Relation heapRelation,
 			if (!HeapTupleIsValid(tuple))
 				elog(ERROR, "cache lookup failed for opclass %u",
 					 classObjectId[i]);
-			opclassTup = (Form_pg_opclass) GETSTRUCT(tuple);
+			opclassTup = GETSTRUCT(pg_opclass, tuple);
 			if (OidIsValid(opclassTup->opckeytype))
 				keyType = opclassTup->opckeytype;
 
@@ -459,7 +459,7 @@ ConstructTupleDescriptor(Relation heapRelation,
 			tuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(keyType));
 			if (!HeapTupleIsValid(tuple))
 				elog(ERROR, "cache lookup failed for type %u", keyType);
-			typeTup = (Form_pg_type) GETSTRUCT(tuple);
+			typeTup = GETSTRUCT(pg_type, tuple);
 
 			to->atttypid = keyType;
 			to->atttypmod = -1;
@@ -812,7 +812,7 @@ index_create(Relation heapRelation,
 				ereport(ERROR,
 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 						 errmsg("nondeterministic collations are not supported for operator class \"%s\"",
-								NameStr(((Form_pg_opclass) GETSTRUCT(classtup))->opcname))));
+								NameStr((GETSTRUCT(pg_opclass, classtup))->opcname))));
 				ReleaseSysCache(classtup);
 			}
 		}
@@ -1547,8 +1547,8 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 	if (!HeapTupleIsValid(newClassTuple))
 		elog(ERROR, "could not find tuple for relation %u", newIndexId);
 
-	oldClassForm = (Form_pg_class) GETSTRUCT(oldClassTuple);
-	newClassForm = (Form_pg_class) GETSTRUCT(newClassTuple);
+	oldClassForm = GETSTRUCT(pg_class, oldClassTuple);
+	newClassForm = GETSTRUCT(pg_class, newClassTuple);
 
 	/* Swap the names */
 	namestrcpy(&newClassForm->relname, NameStr(oldClassForm->relname));
@@ -1577,8 +1577,8 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 	if (!HeapTupleIsValid(newIndexTuple))
 		elog(ERROR, "could not find tuple for relation %u", newIndexId);
 
-	oldIndexForm = (Form_pg_index) GETSTRUCT(oldIndexTuple);
-	newIndexForm = (Form_pg_index) GETSTRUCT(newIndexTuple);
+	oldIndexForm = GETSTRUCT(pg_index, oldIndexTuple);
+	newIndexForm = GETSTRUCT(pg_index, newIndexTuple);
 
 	/*
 	 * Copy constraint flags from the old index. This is safe because the old
@@ -1641,7 +1641,7 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 		if (!HeapTupleIsValid(constraintTuple))
 			elog(ERROR, "could not find tuple for constraint %u", constraintOid);
 
-		conForm = ((Form_pg_constraint) GETSTRUCT(constraintTuple));
+		conForm = (GETSTRUCT(pg_constraint, constraintTuple));
 
 		if (conForm->conindid == oldIndexId)
 		{
@@ -1663,14 +1663,14 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 
 		while (HeapTupleIsValid((triggerTuple = systable_getnext(scan))))
 		{
-			Form_pg_trigger tgForm = (Form_pg_trigger) GETSTRUCT(triggerTuple);
+			Form_pg_trigger tgForm = GETSTRUCT(pg_trigger, triggerTuple);
 
 			if (tgForm->tgconstrindid != oldIndexId)
 				continue;
 
 			/* Make a modifiable copy */
 			triggerTuple = heap_copytuple(triggerTuple);
-			tgForm = (Form_pg_trigger) GETSTRUCT(triggerTuple);
+			tgForm = GETSTRUCT(pg_trigger, triggerTuple);
 
 			tgForm->tgconstrindid = newIndexId;
 
@@ -1776,7 +1776,7 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 
 		while (HeapTupleIsValid((attrTuple = systable_getnext(scan))))
 		{
-			Form_pg_attribute att = (Form_pg_attribute) GETSTRUCT(attrTuple);
+			Form_pg_attribute att = GETSTRUCT(pg_attribute, attrTuple);
 			Datum		repl_val[Natts_pg_attribute];
 			bool		repl_null[Natts_pg_attribute];
 			bool		repl_repl[Natts_pg_attribute];
@@ -2078,7 +2078,7 @@ index_constraint_create(Relation heapRelation,
 										 ObjectIdGetDatum(indexRelationId));
 		if (!HeapTupleIsValid(indexTuple))
 			elog(ERROR, "cache lookup failed for index %u", indexRelationId);
-		indexForm = (Form_pg_index) GETSTRUCT(indexTuple);
+		indexForm = GETSTRUCT(pg_index, indexTuple);
 
 		if (mark_as_primary && !indexForm->indisprimary)
 		{
@@ -2854,7 +2854,7 @@ index_update_stats(Relation rel,
 
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for relation %u", relid);
-	rd_rel = (Form_pg_class) GETSTRUCT(tuple);
+	rd_rel = GETSTRUCT(pg_class, tuple);
 
 	/* Should this be a more comprehensive test? */
 	Assert(rd_rel->relkind != RELKIND_PARTITIONED_INDEX);
@@ -3078,7 +3078,7 @@ index_build(Relation heapRelation,
 										 ObjectIdGetDatum(indexId));
 		if (!HeapTupleIsValid(indexTuple))
 			elog(ERROR, "cache lookup failed for index %u", indexId);
-		indexForm = (Form_pg_index) GETSTRUCT(indexTuple);
+		indexForm = GETSTRUCT(pg_index, indexTuple);
 
 		/* If it's a new index, indcheckxmin shouldn't be set ... */
 		Assert(!indexForm->indcheckxmin);
@@ -3450,7 +3450,7 @@ index_set_state_flags(Oid indexId, IndexStateFlagsAction action)
 									 ObjectIdGetDatum(indexId));
 	if (!HeapTupleIsValid(indexTuple))
 		elog(ERROR, "cache lookup failed for index %u", indexId);
-	indexForm = (Form_pg_index) GETSTRUCT(indexTuple);
+	indexForm = GETSTRUCT(pg_index, indexTuple);
 
 	/* Perform the requested state change on the copy */
 	switch (action)
@@ -3531,7 +3531,7 @@ IndexGetRelation(Oid indexId, bool missing_ok)
 			return InvalidOid;
 		elog(ERROR, "cache lookup failed for index %u", indexId);
 	}
-	index = (Form_pg_index) GETSTRUCT(tuple);
+	index = GETSTRUCT(pg_index, tuple);
 	Assert(index->indexrelid == indexId);
 
 	result = index->indrelid;
@@ -3768,7 +3768,7 @@ reindex_index(Oid indexId, bool skip_constraint_checks, char persistence,
 										 ObjectIdGetDatum(indexId));
 		if (!HeapTupleIsValid(indexTuple))
 			elog(ERROR, "cache lookup failed for index %u", indexId);
-		indexForm = (Form_pg_index) GETSTRUCT(indexTuple);
+		indexForm = GETSTRUCT(pg_index, indexTuple);
 
 		index_bad = (!indexForm->indisvalid ||
 					 !indexForm->indisready ||
diff --git a/src/backend/catalog/namespace.c b/src/backend/catalog/namespace.c
index fafb9349cc..737cc9d64b 100644
--- a/src/backend/catalog/namespace.c
+++ b/src/backend/catalog/namespace.c
@@ -717,7 +717,7 @@ RelationIsVisible(Oid relid)
 	reltup = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(reltup))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	relform = (Form_pg_class) GETSTRUCT(reltup);
+	relform = GETSTRUCT(pg_class, reltup);
 
 	recomputeNamespacePath();
 
@@ -825,7 +825,7 @@ TypeIsVisible(Oid typid)
 	typtup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 	if (!HeapTupleIsValid(typtup))
 		elog(ERROR, "cache lookup failed for type %u", typid);
-	typform = (Form_pg_type) GETSTRUCT(typtup);
+	typform = GETSTRUCT(pg_type, typtup);
 
 	recomputeNamespacePath();
 
@@ -986,7 +986,7 @@ FuncnameGetCandidates(List *names, int nargs, List *argnames,
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	proctup = &catlist->members[i]->tuple;
-		Form_pg_proc procform = (Form_pg_proc) GETSTRUCT(proctup);
+		Form_pg_proc procform = GETSTRUCT(pg_proc, proctup);
 		Oid		   *proargtypes = procform->proargtypes.values;
 		int			pronargs = procform->pronargs;
 		int			effective_nargs;
@@ -1349,7 +1349,7 @@ MatchNamedCall(HeapTuple proctup, int nargs, List *argnames,
 			   bool include_out_arguments, int pronargs,
 			   int **argnumbers)
 {
-	Form_pg_proc procform = (Form_pg_proc) GETSTRUCT(proctup);
+	Form_pg_proc procform = GETSTRUCT(pg_proc, proctup);
 	int			numposargs = nargs - list_length(argnames);
 	int			pronallargs;
 	Oid		   *p_argtypes;
@@ -1466,7 +1466,7 @@ FunctionIsVisible(Oid funcid)
 	proctup = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(proctup))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(proctup);
+	procform = GETSTRUCT(pg_proc, proctup);
 
 	recomputeNamespacePath();
 
@@ -1553,7 +1553,7 @@ OpernameGetOprid(List *names, Oid oprleft, Oid oprright)
 									  ObjectIdGetDatum(namespaceId));
 			if (HeapTupleIsValid(opertup))
 			{
-				Form_pg_operator operclass = (Form_pg_operator) GETSTRUCT(opertup);
+				Form_pg_operator operclass = GETSTRUCT(pg_operator, opertup);
 				Oid			result = operclass->oid;
 
 				ReleaseSysCache(opertup);
@@ -1595,7 +1595,7 @@ OpernameGetOprid(List *names, Oid oprleft, Oid oprright)
 		for (i = 0; i < catlist->n_members; i++)
 		{
 			HeapTuple	opertup = &catlist->members[i]->tuple;
-			Form_pg_operator operform = (Form_pg_operator) GETSTRUCT(opertup);
+			Form_pg_operator operform = GETSTRUCT(pg_operator, opertup);
 
 			if (operform->oprnamespace == namespaceId)
 			{
@@ -1678,7 +1678,7 @@ OpernameGetCandidates(List *names, char oprkind, bool missing_schema_ok)
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		HeapTuple	opertup = &catlist->members[i]->tuple;
-		Form_pg_operator operform = (Form_pg_operator) GETSTRUCT(opertup);
+		Form_pg_operator operform = GETSTRUCT(pg_operator, opertup);
 		int			pathpos = 0;
 		FuncCandidateList newResult;
 
@@ -1800,7 +1800,7 @@ OperatorIsVisible(Oid oprid)
 	oprtup = SearchSysCache1(OPEROID, ObjectIdGetDatum(oprid));
 	if (!HeapTupleIsValid(oprtup))
 		elog(ERROR, "cache lookup failed for operator %u", oprid);
-	oprform = (Form_pg_operator) GETSTRUCT(oprtup);
+	oprform = GETSTRUCT(pg_operator, oprtup);
 
 	recomputeNamespacePath();
 
@@ -1886,7 +1886,7 @@ OpclassIsVisible(Oid opcid)
 	opctup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opcid));
 	if (!HeapTupleIsValid(opctup))
 		elog(ERROR, "cache lookup failed for opclass %u", opcid);
-	opcform = (Form_pg_opclass) GETSTRUCT(opctup);
+	opcform = GETSTRUCT(pg_opclass, opctup);
 
 	recomputeNamespacePath();
 
@@ -1969,7 +1969,7 @@ OpfamilyIsVisible(Oid opfid)
 	opftup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfid));
 	if (!HeapTupleIsValid(opftup))
 		elog(ERROR, "cache lookup failed for opfamily %u", opfid);
-	opfform = (Form_pg_opfamily) GETSTRUCT(opftup);
+	opfform = GETSTRUCT(pg_opfamily, opftup);
 
 	recomputeNamespacePath();
 
@@ -2032,7 +2032,7 @@ lookup_collation(const char *collname, Oid collnamespace, int32 encoding)
 							  ObjectIdGetDatum(collnamespace));
 	if (!HeapTupleIsValid(colltup))
 		return InvalidOid;
-	collform = (Form_pg_collation) GETSTRUCT(colltup);
+	collform = GETSTRUCT(pg_collation, colltup);
 	if (collform->collprovider == COLLPROVIDER_ICU)
 	{
 		if (is_encoding_supported_by_icu(encoding))
@@ -2101,7 +2101,7 @@ CollationIsVisible(Oid collid)
 	colltup = SearchSysCache1(COLLOID, ObjectIdGetDatum(collid));
 	if (!HeapTupleIsValid(colltup))
 		elog(ERROR, "cache lookup failed for collation %u", collid);
-	collform = (Form_pg_collation) GETSTRUCT(colltup);
+	collform = GETSTRUCT(pg_collation, colltup);
 
 	recomputeNamespacePath();
 
@@ -2184,7 +2184,7 @@ ConversionIsVisible(Oid conid)
 	contup = SearchSysCache1(CONVOID, ObjectIdGetDatum(conid));
 	if (!HeapTupleIsValid(contup))
 		elog(ERROR, "cache lookup failed for conversion %u", conid);
-	conform = (Form_pg_conversion) GETSTRUCT(contup);
+	conform = GETSTRUCT(pg_conversion, contup);
 
 	recomputeNamespacePath();
 
@@ -2288,7 +2288,7 @@ StatisticsObjIsVisible(Oid relid)
 	stxtup = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(stxtup))
 		elog(ERROR, "cache lookup failed for statistics object %u", relid);
-	stxform = (Form_pg_statistic_ext) GETSTRUCT(stxtup);
+	stxform = GETSTRUCT(pg_statistic_ext, stxtup);
 
 	recomputeNamespacePath();
 
@@ -2411,7 +2411,7 @@ TSParserIsVisible(Oid prsId)
 	tup = SearchSysCache1(TSPARSEROID, ObjectIdGetDatum(prsId));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for text search parser %u", prsId);
-	form = (Form_pg_ts_parser) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_ts_parser, tup);
 
 	recomputeNamespacePath();
 
@@ -2538,7 +2538,7 @@ TSDictionaryIsVisible(Oid dictId)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for text search dictionary %u",
 			 dictId);
-	form = (Form_pg_ts_dict) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_ts_dict, tup);
 
 	recomputeNamespacePath();
 
@@ -2664,7 +2664,7 @@ TSTemplateIsVisible(Oid tmplId)
 	tup = SearchSysCache1(TSTEMPLATEOID, ObjectIdGetDatum(tmplId));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for text search template %u", tmplId);
-	form = (Form_pg_ts_template) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_ts_template, tup);
 
 	recomputeNamespacePath();
 
@@ -2791,7 +2791,7 @@ TSConfigIsVisible(Oid cfgid)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for text search configuration %u",
 			 cfgid);
-	form = (Form_pg_ts_config) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_ts_config, tup);
 
 	recomputeNamespacePath();
 
@@ -3835,7 +3835,7 @@ recomputeNamespacePath(void)
 			{
 				char	   *rname;
 
-				rname = NameStr(((Form_pg_authid) GETSTRUCT(tuple))->rolname);
+				rname = NameStr((GETSTRUCT(pg_authid, tuple))->rolname);
 				namespaceId = get_namespace_oid(rname, true);
 				ReleaseSysCache(tuple);
 				if (OidIsValid(namespaceId) &&
